-- fichier p_pile_4.ads (corrig)
-- T. Avignon D. Feneuille Oct 2000 
-- pour TD - TP 10
--


generic
   type T_Elem is private; 
   Max_Pile : in Natural;
   -- le max de toutes les piles pour un T_ELEM

package P_Pile_4 is

   subtype T_Max is Natural range 0..Max_Pile;

   type T_Pile 
         (Le_Max : T_Max) is limited private; 
   -- limited interdit l'affectation

   procedure Empiler (
         Une_Pile : in out T_Pile; 
         Elem     : in     T_Elem  ); 

   procedure Depiler (
         Une_Pile : in out T_Pile; 
         Elem     :    out T_Elem  ); 

   function Pile_Vide (
         Une_Pile : in     T_Pile ) 
     return Boolean; 

   function Pile_Pleine (
         Une_Pile : in     T_Pile ) 
     return Boolean; 

   function Haut_Pile (
         Une_Pile : in     T_Pile ) 
     return T_Elem; 

   function Hauteur (
         Une_Pile : in     T_Pile ) 
     return Natural;
   
   procedure Vider_Pile (
         Une_Pile : in out T_pile); 

   Exc_Pile_Pleine,
      Exc_Pile_Vide : exception;

private

   type T_Vect is array (T_Max range <>) of T_Elem; 

   type T_Pile 
         (Le_Max : T_Max) is 
      record 
         Sommet : T_Max := 0;   
       -- en fait entre 0..LE_MAX 
         V      : T_Vect (1 .. Le_Max);  
      end record; 

end P_Pile_4;