-- fichier P_Rationnels_g.adb (corrig)
--  crer de toute pice pour le TP 11
--  partir des spcifications qui sont donnes
-- D. Feneuille 

package body P_Rationnels_G is

   subtype T_Entier_Nat is T_Entier range 0..T_Entier'Last;

   function Pgcd (
         M : T_Entier_Pos; 
         N : T_Entier_Pos  ) 
     return T_Entier_Pos is 

      M_Bis : T_Entier_Nat := M;  
      N_Bis : T_Entier_Nat := N;  

   begin -- PGCD
      while M_Bis /= 0 and N_Bis /= 0 loop
         if (M_Bis > N_Bis) then
            M_Bis := M_Bis rem N_Bis;
         else
            N_Bis := N_Bis rem M_Bis;
         end if;
      end loop;
      return N_Bis + M_Bis;
   end Pgcd;


   function "/" (
         X : T_Entier; 
         Y : T_Entier  ) 
     return T_Rationnel is 

      G : T_Entier_Pos;  

   begin -- "/"

      if Y = 0 then
         raise Zero_Denominateur;
      end if;

      if X = 0 then
         return (
            Numerateur   => 0, 
            Denominateur => 1);
      end if;

      G := Pgcd(abs (X), abs (Y));

      if Y > 0 then
         return (
            Numerateur   => X / G, 
            Denominateur => Y / G);
      else
         return (
            Numerateur   => (- X) / G, 
            Denominateur => (- Y) / G);
      end if;

   end "/";


   function Numer (
         R : T_Rationnel ) 
     return T_Entier is 
   begin -- Numer
      return R.Numerateur;
   end Numer;


   function Denom (
         R : T_Rationnel ) 
     return T_Entier_Pos is 
   begin -- Denom
      return R.Denominateur;
   end Denom;

   function "<" (
         R1 : T_Rationnel; 
         R2 : T_Rationnel  ) 
     return Boolean is 
   begin
      return Numer(R1) * Denom(R2) < Numer(R2) * Denom(R1);
   end "<";

   function ">" (
         R1 : T_Rationnel; 
         R2 : T_Rationnel  ) 
     return Boolean is 
   begin
      return R2 < R1;
   end ">";

   function "<=" (
         R1 : T_Rationnel; 
         R2 : T_Rationnel  ) 
     return Boolean is 
   begin
      return not (R2 < R1);
   end "<=";

   function ">=" (
         R1 : T_Rationnel; 
         R2 : T_Rationnel  ) 
     return Boolean is 
   begin
      return not (R1 < R2);
   end ">=";


   function "+" (
         R : T_Rationnel ) 
     return T_Rationnel is 
   begin -- "+"
      return R;
   end "+";

   function "-" (
         R : T_Rationnel ) 
     return T_Rationnel is 
   begin -- "-"
      return (-Numer(R)) / Denom(R);
   end "-";

   function "abs" (
         R : T_Rationnel ) 
     return T_Rationnel is 
   begin -- "abs"
      return (abs Numer(R)) / Denom(R);
   end "abs";


   function "+" (
         R1 : T_Rationnel; 
         R2 : T_Rationnel  ) 
     return T_Rationnel is 
      N : T_Entier;  
      D : T_Entier_Pos;  
   begin -- "+"
      N := Numer(R1) * Denom(R2) + Numer(R2) * Denom(R1);
      D := Denom(R1) * Denom(R2);
      return N/D;
   end "+";

   function "*" (
         R1 : T_Rationnel; 
         R2 : T_Rationnel  ) 
     return T_Rationnel is 
   begin
      return (Numer(R1)*Numer(R2))/(Denom(R1)*Denom(R2));
   end "*";

   function "-" (
         R1 : T_Rationnel; 
         R2 : T_Rationnel  ) 
     return T_Rationnel is 
   begin
      return R1 + (-R2);
   end "-";

   function "/" (
         R1 : T_Rationnel; 
         R2 : T_Rationnel  ) 
     return T_Rationnel is 
   begin
      return (Numer(R1)*Denom(R2)) / (Numer(R2)*Denom(R1));
   end "/";

   function "*" (
         R1 : T_Rationnel; 
         R2 : T_Entier     ) 
     return T_Rationnel is 
   begin
      return (Numer(R1) * R2) / Denom(R1);
   end "*";

end P_Rationnels_G;
