-- TP 13A
-- fichier p_poly_v1_g.adb
-- D.F. & T.A. (modif 02)

with Ada.Text_Io;

package body P_Poly_V1_G is

   -- procdure qui effectue en une seule passe le calcul
   -- du reste et du quotient de deux polynmes !
   -- dfinie plus bas mais utilise par rem et /

   procedure Calcul (
         Poly_A,                     
         Poly_B : in     T_Polynome; 
         Res,                        
         Quo    :    out T_Polynome  ); 

   -- dbut des sous-programmes

   function "+" (
         Poly_A,                    
         Poly_B : in     T_Polynome ) 
     return T_Polynome is 
      Grand,  
      Petit : T_Polynome;  
   begin
      if Poly_A.Degre >= Poly_B.Degre
            then
         Grand := Poly_A;
         Petit := Poly_B;
      else
         Petit := Poly_A;
         Grand := Poly_B;
      end if;

      for Ind in Petit.Coef'range
            loop
         Grand.Coef(Ind) := Grand.Coef(Ind) + Petit.Coef(Ind);
      end loop;

      return Poly_Reduit(Grand);
   end "+";

   function "-" (
         Poly_A,                    
         Poly_B : in     T_Polynome ) 
     return T_Polynome is 
   begin
      return Poly_A + (-Poly_B);
   end "-";

   function "-" (
         Poly_A : in     T_Polynome ) 
     return T_Polynome is 
      Result : T_Polynome;  
   begin
      Result := Poly_A;
      for Ind in Result.Coef'range
            loop
         Result.Coef(Ind) := - Result.Coef(Ind);
      end loop;
      return Result;
   end "-";

   function "*" (
         Poly_A,                    
         Poly_B : in     T_Polynome ) 
     return T_Polynome is 
      Result : T_Polynome := (Poly_A.Degre + Poly_B.Degre, (others => Nulle));  

   begin
      for Ind_A in Poly_A.Coef'range loop
         for Ind_B in Poly_B.Coef'range loop
            Result.Coef(Ind_A + Ind_B) := Result.Coef(Ind_A + Ind_B) +
               Poly_A.Coef(Ind_A) * Poly_B.Coef(Ind_B);
         end loop;
      end loop;
      return Result;
   end "*";

   function Derivee (
         Poly_A : in     T_Polynome ) 
     return T_Polynome is 
      Result : T_Polynome;  
      -- Result est a priori = (0,(others => 0));  
   begin
      if Poly_A.Degre > 0
            then
         Result := (Poly_A.Degre - 1,(others => Nulle));
         for Ind in 1..Poly_A.Degre loop
            Result.Coef(Ind - 1) := Poly_A.Coef(Ind) * T_Entier(Ind);
         end loop;
      end if;
      return Result;
   end Derivee;

   function "/" (
         Poly_A,                    
         Poly_B : in     T_Polynome ) 
     return T_Polynome is 
      Reste    : T_Polynome;  
      Quotient : T_Polynome;  
   begin
      Calcul (Poly_A, Poly_B, Reste, Quotient);
      return Poly_Reduit(Quotient);
   end "/";

   function "rem" (
         Poly_A,                    
         Poly_B : in     T_Polynome ) 
     return T_Polynome is 
      Reste    : T_Polynome;  
      Quotient : T_Polynome;  
   begin
      Calcul (Poly_A, Poly_B, Reste, Quotient);
      return Poly_Reduit(Reste);
   end "rem";


   procedure Set (
         Poly :    out T_Polynome;  
         Vect : in     T_Liste_Coef ) is 
      V_Coef : T_Vect_Coef (0 .. Vect'Last - 1);  
   begin
      for I in Vect'range
            loop
         V_Coef (I - 1) := Vect (I);
      end loop;
      Poly := (Vect'Length - 1, V_Coef);
   end Set;

   procedure Ecrire (
         Poly : in     T_Polynome ) is --  amliorer peut-tre!
      Result : T_Polynome := Poly_Reduit (Poly);  
   begin
      if   Result.Coef(0) /= Nulle
            then
         P_Rationnels_Io.Put(Result.Coef(0));
         Ada.Text_Io.Put(" ");
      elsif Result.Degre = 0
            then
         Ada.Text_Io.Put("0");
      end if;
      if (Result.Degre >= 1)
            and then (Result.Coef(1) /= Nulle)
            then
         if  Result.Coef(1) > Nulle
               then
            Ada.Text_Io.Put("+");
         end if;
         if   Result.Coef(1) /= 1/1
               then
            P_Rationnels_Io.Put(Result.Coef(1));
         end if;
         Ada.Text_Io.Put("X ");
      end if;
      for Ind in Positive range 2..Result.Coef'Last
            loop
         if  Result.Coef(Ind) > Nulle
               then
            Ada.Text_Io.Put("+");
         end if;
         if   Result.Coef(Ind)  /= Nulle
               then
            if  Result.Coef(Ind) /= 1/1
                  then
               P_Rationnels_Io.Put(Result.Coef(Ind));
            end if;
            Ada.Text_Io.Put("X**");
            Ada.Text_Io.Put(Positive'Image(Ind));
            Ada.Text_Io.Put(" ");
         end if;
      end loop;
      Ada.Text_Io.New_Line;
   end Ecrire;

   -- function ressource POLY_REDUIT fonction locale

   function Poly_Reduit (
         Poly : in     T_Polynome ) 
     return T_Polynome is 
      Degre_Max : T_Degre := Poly.Degre;  
   begin
      loop
         exit when  (Poly.Coef(Degre_Max) /= Nulle)
            or else (Degre_Max = 0);
         Degre_Max := Degre_Max - 1;
      end loop;
      return (Degre_Max , Poly.Coef(0..Degre_Max)); -- agrgat
   end Poly_Reduit;

   procedure Calcul (
         Poly_A,                     
         Poly_B : in     T_Polynome; 
         Res,                        
         Quo    :    out T_Polynome  ) is 
      Reste : T_Polynome  := Poly_A;  
      Div   : T_Rationnel;  
      -- oprations sur Rationnels attention !  
      P        : T_Polynome;  
      Quotient : T_Polynome := (Poly_A.Degre - Poly_B.Degre, (others => Nulle));  
   begin
      loop
         exit when Reste.Degre < Poly_B.Degre;
         Div:= Reste.Coef(Reste.Degre) / Poly_B.Coef(Poly_B.Degre);
         Quotient.Coef(Reste.Degre-Poly_B.Degre):= Div;
         P:=(Reste.Degre-Poly_B.Degre,(others=>Nulle));
         P.Coef(Reste.Degre-Poly_B.Degre):=Div;
         Reste := Poly_Reduit (Reste - Poly_B * P);
      end loop;
      Res := Reste;
      Quo := Quotient;
   end Calcul;

end P_Poly_V1_G;
