-- TP 13A criture d'un paquetage gestion de POLYNOMES
-- fichier p_poly_v1_g.ads  D.F.  & TA 2001
-- type polynme  valeur relle mais  coefficients rationnels
-- on tudie la partie spcifications du paquetage
-- on remarque que les polynmes sont  coefficients rationnels

-- dans cette premire version on suppose que les oprations
-- ne posent aucun problme de dbordement

-- enfin et seulement on crit le corps du paquetage

-- puis on crit un bon programme de test

with P_Rationnels_G;
with P_Rationnels_G.Io;

generic
   Max : Positive;   -- degr maxi des polynmes 
   with package P_Rationnels is new P_Rationnels_G(<>);
   with package P_Rationnels_io is new P_Rationnels.Io(<>);
package P_Poly_V1_G is

    use P_Rationnels;
    use P_Rationnels_Io;

   subtype T_Degre is Natural range 0..Max;

   type T_Polynome (Degre : T_Degre := 0) is private;
   -- le TAD en question

   -- sous-programmes ou mthodes
   function "+" (Poly_A, Poly_B : in T_Polynome) return T_Polynome;
   -- addition de deux polynmes
   function "-" (Poly_A, Poly_B : in T_Polynome) return T_Polynome;
   -- diffrence de deux polynmes
   function "-" (Poly_A : in T_Polynome) return T_Polynome;
   -- le moins unaire
   function "*" (Poly_A, Poly_B : in T_Polynome) return T_Polynome;
   -- produit de deux polynmes
   function "/" (Poly_A, Poly_B : in T_Polynome) return T_Polynome;
   -- quotient  de deux polynmes
   function "rem" (Poly_A, Poly_B : in T_Polynome) return T_Polynome;
   -- reste de la division  de deux polynmes
   function Derivee (Poly_A : in T_Polynome) return T_Polynome;
   -- drive classique sans commentaire
   procedure Ecrire (Poly : in T_Polynome);
   -- pour controler dans les tests succincts
   
   -- constructeur :
   type T_Liste_Coef is array (Positive range <>) of T_Rationnel;

   procedure Set (Poly : out T_Polynome; Vect : in T_Liste_Coef);
   -- permet d'initialiser directement un polynome 
   -- avec une liste de coefficients tel que :
   -- Le_Poly := (-1/3,0,3/2,-6); pour -1/3 +(3/2)X**2 -6X**3

   -- plus tard (version 2) ajouter exceptions et
   -- d'autres mthodes (accesseurs et modifieurs) et des E/S.

private

   type T_Vect_Coef is array (T_Degre range <>) of T_Rationnel;

   type T_Polynome (Degre : T_Degre := 0) is -- type mutant
   record
      Coef : T_Vect_Coef (0..Degre) := (others => Nulle);
   end record;
   -- ainsi une instance de ce type est le polynme nul

   function Poly_Reduit (Poly: in T_Polynome) return T_Polynome;
   -- utile pour la hirarchie des paquetages
end P_Poly_V1_G;
