-- TP 17 Testabilit
-- D.F.

with  Ada.Text_Io;           use Ada.Text_Io;
with  Ada.Exceptions;        use Ada.Exceptions;
with Ada.Strings.Fixed;      use Ada.Strings.Fixed;
                             use Ada.Strings;
package body Dri_Poly is

   -- dclarations des "outils" locaux :

   Fic_In : File_Type;


   procedure Ouvrir (
         Fich : in out File_Type );

   package E_S_Degre is new Integer_Io (Natural);
   use E_S_Degre;

   -- ralisation des corps

   procedure Tst_Get_Put is -- comment en TD
      Poly : P_Poly_V1.T_Polynome;
   begin
      Ouvrir (Fic_In);
      Skip_Line (Fic_In);
      -- avec un Skip_Line (Fic_In) ici
      -- on peut vider la ligne commentaires
      -- (premire ligne) du fichier
      Put_Line ("test de Test_Get_Put");
      loop
         exit when End_Of_File(Fic_In);
         begin
            P_Poly_V3.Get(Fic_In,Poly);  -- les 2 exceptions sont testes
            P_Poly_V3.Put(Poly);
            New_Line;
         exception
            when Marqueur : others  =>
               Put_Line (Exception_Name( Marqueur));
         end;
      end loop;
      Close(Fic_In);
   end Tst_Get_Put;


   procedure Tst_Set_Put is -- comment en TD
      Poly : P_Poly_V1.T_Polynome;
      Vect : P_Poly_V1.T_Liste_Coef (1 .. Max + 1);
      I,
      Long,
      Last : Natural;
      Str  : String (1 .. 80);
      -- pour changer des Unbounded
   begin
      Ouvrir (Fic_In);
      Skip_Line (Fic_In);
      -- avec un Skip_Line (Fic_In) ici
      -- on peut vider la ligne commentaires
      -- (premire ligne) du fichier
      Put_Line ("test de Tst_Set_Put");
      loop
         exit when End_Of_File(Fic_In);
         begin
            Get_Line(Fic_In,Str,Long);
            Str(Long+1..80):= (others=>' ');
            Trim (Str,Side=>Both);
            I:=0;
            loop
               exit when Str = "*"(80," ");
               I:= I+1;
               P_Rationnels_Io.Get(Str,Vect(I),Last );
               Delete (Str,1,Last);
               Trim (Str,Side => Both);
            end loop;
            P_Poly_V3.Set(Poly,Vect(1..I));
            -- les 2 exceptions sont testes
            P_Poly_V3.Put(Poly);
            New_Line;
         exception
            when Marqueur : others  =>
               Put_Line (Exception_Name( Marqueur));
         end;
      end loop;
      Close(Fic_In);
   end Tst_Set_Put;

   procedure Tst_Get_Coef is --  faire ensemble
      Poly  : P_Poly_V1.T_Polynome;
      Degre : Natural;
   begin
      Ouvrir (Fic_In);
      Skip_Line (Fic_In);
      Put_Line ("test de TST_Get_Coef");
      loop
         exit when End_Of_File(Fic_In);
         P_Poly_V3.Get(Fic_In,Poly);
         E_S_Degre.Get(Fic_In,Degre);
         Skip_Line(Fic_In);
         begin
            P_Rationnels_Io.Put(P_Poly_V3.Get_Coef(Poly,Degre));
            New_Line;
         exception
            when Marqueur : others  =>
               Put_Line (Exception_Name( Marqueur));
         end;
      end loop;
      Close(Fic_In);
   end Tst_Get_Coef;

   procedure Tst_Valeur is --  faire faire
      package Es_Float is new Float_Io(Float);
      use Es_Float;
      Poly : P_Poly_V1.T_Polynome;
      Val  : Float;
   begin
      Ouvrir (Fic_In);
      Skip_Line (Fic_In);
      Put_Line ("test de TST_Valeur");
      loop
         exit when End_Of_File(Fic_In);
         P_Poly_V3.Get(Fic_In,Poly);
         Es_Float.Get(Fic_In,Val);
         Skip_Line(Fic_In);
         begin
            Put(P_Poly_V3.Valeur(Poly,Val), Exp => 0);
            New_Line;
         exception
            -- pas d'exception  traiter
            when Marqueur : others  =>
               Put_Line (Exception_Name( Marqueur));
         end;
      end loop;
      Close(Fic_In);
   end Tst_Valeur;

   procedure Tst_Derivee is --  faire
      Poly : P_Poly_V1.T_Polynome;
   begin
      Ouvrir (Fic_In);
      Skip_Line (Fic_In);
      Put_Line ("test de TST_Derivee");
      loop
         exit when End_Of_File(Fic_In);
         P_Poly_V3.Get(Fic_In,Poly);
         begin
            P_Poly_V3.Put(P_Poly_V3.Derivee(Poly));
            New_Line;
         exception
            -- pas d'exception  traiter
            when Marqueur : others  =>
               Put_Line (Exception_Name( Marqueur));
         end;
      end loop;
      Close(Fic_In);
   end Tst_Derivee;

   procedure Tst_Get_Degre is --  faire
      Poly : P_Poly_V1.T_Polynome;
   begin
      Ouvrir (Fic_In);
      Skip_Line (Fic_In);
      Put_Line ("test de get_degre");
      loop
         exit when End_Of_File(Fic_In);
         P_Poly_V3.Get(Fic_In,Poly);
         begin
            Put(P_Poly_V3.Get_Degre(Poly));
            New_Line;
         exception
            -- pas d'exception  traiter
            when Marqueur : others  =>
               Put_Line (Exception_Name( Marqueur));
         end;
      end loop;
      Close(Fic_In);
   end Tst_Get_Degre;

   -- ralisation des outils

   procedure Ouvrir (
         Fich : in out File_Type ) is
      Nom : String (1 .. 80);
      Lon : Natural;
   begin
      Put("nom du fichier FIC_IN : ");
      Get_Line(Nom,Lon);
      Open (
         File => Fich,
         Name => Nom (1 .. Lon),
         Mode => In_File);
      -- on pourrait grer l'exception NAME_ERROR!
   end Ouvrir;

end Dri_Poly;
